import { Connection as ConnectionOverride } from "./types";
import { Address, AccountIndex, EthereumSigner, EthereumProvider, Connection, ConnectionConfig, ConnectionConfigs } from "./Connection";
import { Client, Plugin, PluginManifest, PluginModules, PluginFactory } from "@web3api/core-js";
import { ethers } from "ethers";
export { Address, AccountIndex, EthereumSigner, EthereumProvider, ConnectionConfig, ConnectionConfigs, };
export interface EthereumConfig {
    networks: ConnectionConfigs;
    defaultNetwork?: string;
}
export declare class EthereumPlugin extends Plugin {
    private _connections;
    private _defaultNetwork;
    constructor(config: EthereumConfig);
    static manifest(): PluginManifest;
    getModules(_client: Client): PluginModules;
    deployContract(abi: ethers.ContractInterface, bytecode: string, args: string[], connectionOverride?: ConnectionOverride): Promise<Address>;
    callView(address: Address, method: string, args: string[], connectionOverride?: ConnectionOverride): Promise<string>;
    sendTransaction(address: Address, method: string, args: string[], connectionOverride?: ConnectionOverride): Promise<string>;
    getConnection(connectionOverride?: ConnectionOverride): Promise<Connection>;
}
export declare const ethereumPlugin: PluginFactory<EthereumConfig>;
export declare const plugin: PluginFactory<EthereumConfig>;
