"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.plugin = exports.ethereumPlugin = exports.EthereumPlugin = void 0;
/* eslint-disable import/no-extraneous-dependencies */
var resolvers_1 = require("./resolvers");
var manifest_1 = require("./manifest");
var Connection_1 = require("./Connection");
var core_js_1 = require("@web3api/core-js");
var ethers_1 = require("ethers");
var EthereumPlugin = /** @class */ (function (_super) {
    __extends(EthereumPlugin, _super);
    function EthereumPlugin(config) {
        var _this = _super.call(this) || this;
        _this._connections = Connection_1.Connection.fromConfigs(config.networks);
        // Assign the default network (mainnet if not provided)
        if (config.defaultNetwork) {
            _this._defaultNetwork = config.defaultNetwork;
        }
        else {
            _this._defaultNetwork = "mainnet";
        }
        // Create a connection for the default network if none exists
        if (!_this._connections[_this._defaultNetwork]) {
            _this._connections[_this._defaultNetwork] = Connection_1.Connection.fromNetwork(_this._defaultNetwork);
        }
        return _this;
    }
    EthereumPlugin.manifest = function () {
        return manifest_1.manifest;
    };
    // TODO: generated types here from the schema.graphql to ensure safety `Resolvers<TQuery, TMutation>`
    // https://github.com/web3-api/monorepo/issues/101
    EthereumPlugin.prototype.getModules = function (_client) {
        return {
            query: resolvers_1.query(this),
            mutation: resolvers_1.mutation(this),
        };
    };
    EthereumPlugin.prototype.deployContract = function (abi, bytecode, args, connectionOverride) {
        return __awaiter(this, void 0, void 0, function () {
            var connection, signer, factory, contract;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getConnection(connectionOverride)];
                    case 1:
                        connection = _a.sent();
                        signer = connection.getSigner();
                        factory = new ethers_1.ethers.ContractFactory(abi, bytecode, signer);
                        return [4 /*yield*/, factory.deploy.apply(factory, args)];
                    case 2:
                        contract = _a.sent();
                        return [4 /*yield*/, contract.deployTransaction.wait()];
                    case 3:
                        _a.sent();
                        return [2 /*return*/, contract.address];
                }
            });
        });
    };
    EthereumPlugin.prototype.callView = function (address, method, args, connectionOverride) {
        return __awaiter(this, void 0, void 0, function () {
            var connection, contract, funcs, res;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getConnection(connectionOverride)];
                    case 1:
                        connection = _a.sent();
                        contract = connection.getContract(address, [method], false);
                        funcs = Object.keys(contract.interface.functions);
                        return [4 /*yield*/, contract[funcs[0]].apply(contract, args)];
                    case 2:
                        res = _a.sent();
                        return [2 /*return*/, res.toString()];
                }
            });
        });
    };
    EthereumPlugin.prototype.sendTransaction = function (address, method, args, connectionOverride) {
        return __awaiter(this, void 0, void 0, function () {
            var connection, contract, funcs, tx, res;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getConnection(connectionOverride)];
                    case 1:
                        connection = _a.sent();
                        contract = connection.getContract(address, [method]);
                        funcs = Object.keys(contract.interface.functions);
                        return [4 /*yield*/, contract[funcs[0]].apply(contract, args)];
                    case 2:
                        tx = _a.sent();
                        return [4 /*yield*/, tx.wait()];
                    case 3:
                        res = _a.sent();
                        // TODO: improve this
                        return [2 /*return*/, res.transactionHash];
                }
            });
        });
    };
    EthereumPlugin.prototype.getConnection = function (connectionOverride) {
        return __awaiter(this, void 0, void 0, function () {
            var networkNameOrChainId, node, connection, chainId, nodeConnection, nodeNetwork, establishedConnection;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!connectionOverride) {
                            return [2 /*return*/, this._connections[this._defaultNetwork]];
                        }
                        networkNameOrChainId = connectionOverride.networkNameOrChainId, node = connectionOverride.node;
                        // If a custom network is provided, either get an already
                        // established connection, or a create a new one
                        if (networkNameOrChainId) {
                            if (this._connections[networkNameOrChainId]) {
                                connection = this._connections[networkNameOrChainId];
                            }
                            else {
                                chainId = Number.parseInt(networkNameOrChainId);
                                if (!isNaN(chainId)) {
                                    connection = Connection_1.Connection.fromNetwork(chainId);
                                }
                                else {
                                    connection = Connection_1.Connection.fromNetwork(networkNameOrChainId);
                                }
                            }
                        }
                        else {
                            connection = this._connections[this._defaultNetwork];
                        }
                        if (!node) return [3 /*break*/, 2];
                        nodeConnection = Connection_1.Connection.fromNode(node);
                        return [4 /*yield*/, nodeConnection.getProvider().getNetwork()];
                    case 1:
                        nodeNetwork = _a.sent();
                        establishedConnection = this._connections[nodeNetwork.chainId.toString()] ||
                            this._connections[nodeNetwork.name];
                        if (establishedConnection) {
                            try {
                                nodeConnection.setSigner(establishedConnection.getSigner());
                            }
                            catch (e) {
                                // It's okay if there isn't a signer available.
                            }
                        }
                        connection = nodeConnection;
                        _a.label = 2;
                    case 2: return [2 /*return*/, connection];
                }
            });
        });
    };
    return EthereumPlugin;
}(core_js_1.Plugin));
exports.EthereumPlugin = EthereumPlugin;
exports.ethereumPlugin = function (opts) {
    return {
        factory: function () { return new EthereumPlugin(opts); },
        manifest: manifest_1.manifest,
    };
};
exports.plugin = exports.ethereumPlugin;
//# sourceMappingURL=index.js.map